// DlgProxy.cpp : implementation file
//

#include "stdafx.h"
#include "JabApp.h"
#include "DlgProxy.h"
#include "JabAppDlg.h"
#include <afxctl.h>
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CJabEventsSink

IMPLEMENT_DYNCREATE(CJabEventsSink, CCmdTarget)

CJabEventsSink::CJabEventsSink()
{
	EnableAutomation();
	
	// To keep the application running as long as an automation 
	//	object is active, the constructor calls AfxOleLockApp.
	AfxOleLockApp();
	
	// Get access to the dialog through the application's
	//  main window pointer.  Set the proxy's internal pointer
	//  to point to the dialog, and set the dialog's back pointer to
	//  this proxy.
	ASSERT (AfxGetApp()->m_pMainWnd != NULL);
	ASSERT_VALID (AfxGetApp()->m_pMainWnd);
	ASSERT_KINDOF(CJabAppDlg, AfxGetApp()->m_pMainWnd);
	m_pDialog = (CJabAppDlg*) AfxGetApp()->m_pMainWnd;
	m_pDialog->m_pAutoProxy = this;
}

CJabEventsSink::~CJabEventsSink()
{
	// To terminate the application when all objects created with
	// 	with automation, the destructor calls AfxOleUnlockApp.
	//  Among other things, this will destroy the main dialog
	if (m_pDialog != NULL)
		m_pDialog->m_pAutoProxy = NULL;
	AfxOleUnlockApp();
}

void CJabEventsSink::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.
	
	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CJabEventsSink, CCmdTarget)
//{{AFX_MSG_MAP(CJabEventsSink)
// NOTE - the ClassWizard will add and remove mapping macros here.
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CJabEventsSink, CCmdTarget)
//{{AFX_DISPATCH_MAP(CJabEventsSink)
DISP_FUNCTION(CJabEventsSink, "OnConnect", OnConnect, VT_EMPTY, VTS_NONE)
DISP_FUNCTION(CJabEventsSink, "OnDisconnect", OnDisconnect, VT_EMPTY, VTS_NONE)
DISP_FUNCTION(CJabEventsSink, "OnAuthError", OnAuthError, VT_EMPTY, VTS_BSTR)
DISP_FUNCTION(CJabEventsSink, "OnCommError", OnCommError, VT_EMPTY, VTS_BSTR)
DISP_FUNCTION(CJabEventsSink, "OnQueryError", OnQueryError, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_DISPATCH)
DISP_FUNCTION(CJabEventsSink, "OnRosterStart", OnRosterStart, VT_EMPTY, VTS_NONE)
DISP_FUNCTION(CJabEventsSink, "OnRosterItem", OnRosterItem, VT_EMPTY, VTS_DISPATCH)
DISP_FUNCTION(CJabEventsSink, "OnRosterEnd", OnRosterEnd, VT_EMPTY, VTS_NONE)
DISP_FUNCTION(CJabEventsSink, "OnMessage", OnMessage, VT_EMPTY, VTS_DISPATCH VTS_DISPATCH)
DISP_FUNCTION(CJabEventsSink, "OnPresence", OnPresence, VT_EMPTY, VTS_BSTR VTS_BOOL VTS_BSTR VTS_BOOL VTS_DISPATCH)
DISP_FUNCTION(CJabEventsSink, "OnSubscriptionRequest", OnSubscriptionRequest, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_BSTR)
DISP_FUNCTION(CJabEventsSink, "OnSubscriptionApproved", OnSubscriptionApproved, VT_EMPTY, VTS_BSTR VTS_BSTR)
DISP_FUNCTION(CJabEventsSink, "OnSubscriptionDenied", OnSubscriptionDenied, VT_EMPTY, VTS_BSTR VTS_BSTR)
DISP_FUNCTION(CJabEventsSink, "OnXML", OnXML, VT_EMPTY, VTS_I4 VTS_BSTR)
DISP_FUNCTION(CJabEventsSink, "OnJabberIQ", OnJabberIQ, VT_EMPTY, VTS_BSTR VTS_DISPATCH)
DISP_FUNCTION(CJabEventsSink, "OnUnhandledQuery", OnUnhandledQuery, VT_EMPTY, VTS_BSTR VTS_DISPATCH)
DISP_FUNCTION(CJabEventsSink, "OnAgentsStart", OnAgentsStart, VT_EMPTY, VTS_NONE)
DISP_FUNCTION(CJabEventsSink, "OnAgentItem", OnAgentItem, VT_EMPTY, VTS_DISPATCH VTS_BSTR)
DISP_FUNCTION(CJabEventsSink, "OnAgentsEnd", OnAgentsEnd, VT_EMPTY, VTS_NONE)
DISP_FUNCTION(CJabEventsSink, "OnXMLTag", OnXMLTag, VT_EMPTY, VTS_DISPATCH)
DISP_FUNCTION(CJabEventsSink, "OnVersionGet", OnVersionGet, VT_EMPTY, VTS_BSTR VTS_DISPATCH)
DISP_FUNCTION(CJabEventsSink, "OnTimeGet", OnTimeGet, VT_EMPTY, VTS_BSTR VTS_DISPATCH)
DISP_FUNCTION(CJabEventsSink, "OnGetOOB", OnGetOOB, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_BSTR VTS_DISPATCH)

// NOTE - the ClassWizard will add and remove mapping macros here.
//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IJabApp to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {D1CB8A6B-9AD7-416B-9DC6-8B19952DFAE0}
static const IID IID_IJabApp =
{ 0xd1cb8a6b, 0x9ad7, 0x416b, { 0x9d, 0xc6, 0x8b, 0x19, 0x95, 0x2d, 0xfa, 0xe0 } };

BEGIN_INTERFACE_MAP(CJabEventsSink, CCmdTarget)
INTERFACE_PART(CJabEventsSink, IID_IJabberSessionEventSink, Dispatch)			// THIS IS THE MOST IMPORTANT PART. REPLACE THE 3RD DEFAULT PARAMETER WITH OUR "IID_IJabberSessionEventSink". ELSE U WONT HAVE EVENT-HANDLING
END_INTERFACE_MAP()

// The IMPLEMENT_OLECREATE2 macro is defined in StdAfx.h of this project
// {3ECFADF7-C3C9-4713-BBD8-14ABA17B9827}
IMPLEMENT_OLECREATE2(CJabEventsSink, "JabApp.Application", 0x3ecfadf7, 0xc3c9, 0x4713, 0xbb, 0xd8, 0x14, 0xab, 0xa1, 0x7b, 0x98, 0x27)

/////////////////////////////////////////////////////////////////////////////
// CJabEventsSink message handlers


void CJabEventsSink::OnConnect() 
{
	// TODO: Add your dispatch handler code here
	
	
}


void CJabEventsSink::OnDisconnect() 
{
	
	
}

void CJabEventsSink::OnAuthError(LPCTSTR txt) 
{
	// TODO: Add your dispatch handler code here
	
}

void CJabEventsSink::OnCommError(LPCTSTR txt) 
{
	// TODO: Add your dispatch handler code here
}

void CJabEventsSink::OnQueryError(LPCTSTR txt, LPCTSTR fromJID, JabberCOM::IXMLTagPtr xmlTag) 
{
	
}

void CJabEventsSink::OnRosterStart() 
{
}

void CJabEventsSink::OnRosterItem(JabberCOM::IJabberRosterItemPtr item) 
{
	BSTR _str = item->GetUserID() ;
	CString tmp( (wchar_t*)_str) ;
}

void CJabEventsSink::OnRosterEnd() 
{
}

void CJabEventsSink::OnMessage(JabberCOM::IJabberMsgPtr message, JabberCOM::IXMLTagPtr xmlTag) 
{
	message.AddRef() ;
	BSTR _str = message->GetBody() ;
	CString msg = (wchar_t*)_str ;
	m_pDialog->setResponse(msg) ;
}

void CJabEventsSink::OnPresence(LPCTSTR presJID, BOOL available, LPCTSTR status, BOOL inRoster, JabberCOM::IXMLTagPtr xmlTag) 
{
	
}

void CJabEventsSink::OnSubscriptionRequest(LPCTSTR fromJID, LPCTSTR subType, LPCTSTR status) 
{
}

void CJabEventsSink::OnSubscriptionApproved(LPCTSTR fromJID, LPCTSTR status) 
{
	
}

void CJabEventsSink::OnSubscriptionDenied(LPCTSTR fromJID, LPCTSTR status) 
{
	
}

void CJabEventsSink::OnXML(long direction, LPCTSTR txt) 
{
	
}

void CJabEventsSink::OnJabberIQ(LPCTSTR nSpace, JabberCOM::IJabberIQPtr IQ) 
{
	
}

void CJabEventsSink::OnUnhandledQuery(LPCTSTR nSpace, JabberCOM::IXMLTagPtr xmlTag) 
{
	
}

void CJabEventsSink::OnAgentsStart() 
{
	// TODO: Add your dispatch handler code here
	
}

void CJabEventsSink::OnAgentItem(JabberCOM::IJabberAgentItemPtr agent, LPCTSTR iqID) 
{
	// TODO: Add your dispatch handler code here
}

void CJabEventsSink::OnAgentsEnd() 
{
	
}

void CJabEventsSink::OnXMLTag(JabberCOM::IXMLTagPtr xmlTag) 
{
}

void CJabEventsSink::OnVersionGet(LPCTSTR fromJID, JabberCOM::IXMLTagPtr xmlTag) 
{
	
}

void CJabEventsSink::OnTimeGet(LPCTSTR fromJID, JabberCOM::IXMLTagPtr xmlTag) 
{
	
}

void CJabEventsSink::OnGetOOB(LPCTSTR fromJID, LPCTSTR URL, LPCTSTR desc, JabberCOM::IXMLTagPtr xmlTag) 
{
	
}

BOOL CJabEventsSink::Connect(LPCTSTR szUserName, LPCTSTR szPassword, LPCTSTR szServer, LPCTSTR szResource, BOOL bNewUser)
{
/* Could not find an easy way to convert a LPCTSTR to BSTR so using a CString object and 
then calling AllocSysString() on that....
I am not really comfortable with the MFC/Windows platform APIs
	*/
	CString username(szUserName) ;
	CString password(szPassword) ;
	CString server(szServer) ;
	CString resource(szResource) ;
	if(m_bCOMInitialized != TRUE)
	{
		initCOMLibrary() ;
	}
	if(m_bCOMInitialized == TRUE)
	{
		m_pJabberSession->PutUsername(username.AllocSysString());
		m_pJabberSession->PutPassword(password.AllocSysString());
		m_pJabberSession->PutServer(server.AllocSysString());
		m_pJabberSession->PutResource(resource.AllocSysString());
		m_pJabberSession->DoConnect(bNewUser , JabberCOM::jatAuto) ;
		BOOL result = m_pJabberSession->GetActive();
		if(result = TRUE)
		{
			m_pJabberSession->PutAvailable(TRUE) ;
			m_pJabberSession->SendMyPresence() ;
		}
		return result ;
	}
	else
		return FALSE ;
}

BOOL CJabEventsSink::Disconnect(BOOL now)
{
/* I do not know why , but this disconnect seems to be throwing an exception
Anyone tell me why ?? I am a newbie to COM/ActiveX and the like
	*/
	if(m_pJabberSession)
	{
		m_pJabberSession->PutAvailable(FALSE) ;
		try
		{
			HRESULT hr =  m_pJabberSession->DoDisconnect(now) ;
			if(SUCCEEDED(hr))
			{
				AfxConnectionUnadvise(m_pJabberSession, IID_IJabberSessionEventSink, pUnkSink, FALSE, m_dwCookie);
				m_pJabberSession.Release() ;
				return TRUE ;
			}
		}
		catch(_com_error error)
		{
			AfxConnectionUnadvise(m_pJabberSession, IID_IJabberSessionEventSink, pUnkSink, FALSE, m_dwCookie);
			m_pJabberSession.Release() ;
		}
		delete this ;
	}
	return FALSE ;
}

BOOL CJabEventsSink::sendMsg(LPCTSTR msg, LPCTSTR toJID)
{
/* Send a txt message to the tiJID user...
	*/
	if(m_pJabberSession)
	{
		CString to(toJID) ;
		CString from(( wchar_t*)m_pJabberSession->GetMyJID()) ;
		CString message(msg) ;
		JabberCOM::IJabberMsgPtr msgPtr = m_pJabberSession->CreateMsg() ;
		msgPtr->PutToJID(to.AllocSysString()) ;
		msgPtr->PutFromJID(from.AllocSysString()) ;
		msgPtr->PutBody(message.AllocSysString()) ;
		HRESULT hr = m_pJabberSession->SendMessage(msgPtr) ;
		if(SUCCEEDED(hr))
		{
			return TRUE ;
		}
	}
	return FALSE ;
}

JabberCOM::IJabberRosterPtr CJabEventsSink::GetRoster()
{
	return m_pJabberSession->GetRoster() ;
}

BOOL CJabEventsSink::initCOMLibrary()
{
	if(m_bCOMInitialized == TRUE)
	{
		return m_bCOMInitialized ;
	}
	HRESULT hr = CoInitialize(NULL) ;
	if(!SUCCEEDED(hr))
	{
		AfxMessageBox("COM Library Initialization failed.") ;
		return m_bCOMInitialized ;
	}
	
	hr = m_pJabberSession.CreateInstance("JabberCOM.JabberSession");
	if(!SUCCEEDED(hr))
	{
		AfxMessageBox("Instance Creation Failed") ;
		return m_bCOMInitialized ;
	}
	pUnkSink = GetIDispatch(FALSE);
	if (!AfxConnectionAdvise(m_pJabberSession, IID_IJabberSessionEventSink, pUnkSink, FALSE, &m_dwCookie))
	{
		AfxMessageBox("AfxConnectionAdvise failed.", MB_OK, 0);
		return m_bCOMInitialized ;
	}
	m_bCOMInitialized = TRUE ;
	return m_bCOMInitialized ;
}